package cn.zhangdeman.exception;
import lombok.Getter;
import lombok.Setter;


// 自定义异常
@Getter
@Setter
public class CustomException extends RuntimeException {
    private final String code; // 错误码
    private final String message; // 异常信息
    private final String category; // 错误分类
    private final Object data; // 异常数据
    public CustomException(String message) {
        super(message);
        this.code = "-1";
        this.category = "-1";
        this.data = null;
        this.message = message;
    }

    public CustomException(ICustomExceptionConfig iCustomExceptionConfig) {
        this.code = iCustomExceptionConfig.getCode();
        this.message = iCustomExceptionConfig.getMessage();
        this.category = iCustomExceptionConfig.getCategory();
        this.data = null;
    }

    // 根据code与
    public CustomException(ICustomExceptionConfig iCustomExceptionConfig, Object data) {
        this.code = iCustomExceptionConfig.getCode();
        this.message = iCustomExceptionConfig.getMessage();
        this.category = iCustomExceptionConfig.getCategory();
        this.data = data;
    }
    public CustomException(String category, String code, Object data) {
        this.category = category;
        this.code = code;
        this.message = HashMapCache.getInstance().getMessage(category, code);
        this.data = data;
    }

    // 是否制定分类的错误
    public Boolean isCategory(String category) {
        return this.category.equals(category);
    }

    // 是否指定分类下的指定错误
    public Boolean isErrorCode(String category, String code) {
        return this.category.equals(category) && this.code.equals(code);
    }
}