package cn.zhangdeman.exception.annotation;

import java.lang.annotation.*;

// 自定义异常注解分类
@Retention(RetentionPolicy.RUNTIME) // 定带有注解类型的注解要保留多长时间。它需要一个RetentionPolicy参数，可以是SOURCE、CLASS或 之一RUNTIME。例如，@Retention(RetentionPolicy.RUNTIME)意味着注解应该由 JVM 保留，以便可以在运行时反射性地使用。
@Target(ElementType.TYPE) // 注解会施加在自定义异常类之上
@Inherited // @Inherited注解表示注解类型被自动继承。如果一个类被标注了@Inherited，那么它的子类也会继承该注解。
public @interface CustomExceptionCategoryAnnotation {
    String category() default "common"; // 异常所属分类
}
